package com.tzld.piaoquan.longarticle.service.local.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.PlanAccountMapper;
import com.tzld.piaoquan.longarticle.model.po.PlanAccount;
import com.tzld.piaoquan.longarticle.model.po.PlanAccountExample;
import com.tzld.piaoquan.longarticle.service.local.PlanAccountService;
import com.tzld.piaoquan.longarticle.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class PlanAccountServiceImpl implements PlanAccountService {

    @Autowired
    private PlanAccountMapper planAccountMapper;

    public void saveOrUpdatePlanAccount(PlanAccount planAccount) {
        PlanAccountExample example = new PlanAccountExample();
        example.createCriteria().andAccountIdEqualTo(planAccount.getAccountId())
                .andPlanIdEqualTo(planAccount.getPlanId())
                .andCreateTimeGreaterThan(DateUtil.getThatDayDate());
        List<PlanAccount> planAccounts = planAccountMapper.selectByExample(example);
        if (CollectionUtils.isEmpty(planAccounts)) {
            planAccountMapper.insertSelective(planAccount);
        } else {
            planAccount.setId(planAccounts.get(0).getId());
            planAccountMapper.updateByPrimaryKeySelective(planAccount);
        }
    }

    public List<PlanAccount> getMatchPlanAccount() {
        PlanAccountExample example = new PlanAccountExample();
        example.createCriteria().andCreateTimeGreaterThan(DateUtil.getThatDayDate())
                .andMatchStatusEqualTo(0);
        return planAccountMapper.selectByExample(example);
    }


    @Override
    public void updateMatchStatus(Integer status, Long id) {
        PlanAccount updatePlanAccount = new PlanAccount();
        updatePlanAccount.setId(id);
        updatePlanAccount.setMatchStatus(status);
        planAccountMapper.updateByPrimaryKey(updatePlanAccount);
    }

    @Override
    public void updateStatus(Integer status, Long id) {
        PlanAccount updatePlanAccount = new PlanAccount();
        updatePlanAccount.setId(id);
        updatePlanAccount.setStatus(status);
        planAccountMapper.updateByPrimaryKey(updatePlanAccount);
    }

}
